diff --git a/doc/src/sgml/plpython.sgml b/doc/src/sgml/plpython.sgml
index c447452b7c5..8fb19a89666 100644
--- a/doc/src/sgml/plpython.sgml
+++ b/doc/src/sgml/plpython.sgml
@@ -46,7 +46,7 @@
   </para>
  </note>
 
- <sect1 id="plpython-funcs">
+ <sect1 id="plpython-funcs" xreflabel="PL/Python Functions">
   <title>PL/Python Functions</title>
 
   <para>
@@ -144,7 +144,7 @@ $$ LANGUAGE plpython3u;
   </para>
  </sect1>
 
- <sect1 id="plpython-data">
+ <sect1 id="plpython-data" xreflabel="Data Values">
   <title>Data Values</title>
   <para>
    Generally speaking, the aim of PL/Python is to provide
@@ -153,7 +153,7 @@ $$ LANGUAGE plpython3u;
    below.
   </para>
 
-  <sect2 id="plpython-data-type-mapping">
+  <sect2 id="plpython-data-type-mapping" xreflabel="Data Type Mapping">
    <title>Data Type Mapping</title>
    <para>
     When a PL/Python function is called, its arguments are converted from
@@ -269,7 +269,7 @@ $$ LANGUAGE plpython3u;
    </para>
   </sect2>
 
-  <sect2 id="plpython-data-null">
+  <sect2 id="plpython-data-null" xreflabel="Null, None">
    <title>Null, None</title>
   <para>
    If an SQL null value<indexterm><primary>null value</primary><secondary
@@ -301,7 +301,7 @@ $$ LANGUAGE plpython3u;
   </para>
   </sect2>
 
-  <sect2 id="plpython-arrays">
+  <sect2 id="plpython-arrays" xreflabel="Arrays, Lists">
    <title>Arrays, Lists</title>
   <para>
    SQL array values are passed into PL/Python as a Python list.  To
@@ -369,7 +369,7 @@ SELECT return_str_arr();
   </para>
   </sect2>
 
-  <sect2 id="plpython-data-composite-types">
+  <sect2 id="plpython-data-composite-types" xreflabel="Composite Types">
    <title>Composite Types</title>
   <para>
    Composite-type arguments are passed to the function as Python mappings. The
@@ -516,7 +516,7 @@ CALL python_triple(5, 10);
    </para>
   </sect2>
 
-  <sect2 id="plpython-data-set-returning-funcs">
+  <sect2 id="plpython-data-set-returning-funcs" xreflabel="Set-Returning Functions">
    <title>Set-Returning Functions</title>
   <para>
    A <application>PL/Python</application> function can also return sets of
@@ -616,7 +616,7 @@ SELECT * FROM multiout_simple_setof(3);
   </sect2>
  </sect1>
 
- <sect1 id="plpython-sharing">
+ <sect1 id="plpython-sharing" xreflabel="Sharing Data">
   <title>Sharing Data</title>
   <para>
    The global dictionary <varname>SD</varname> is available to store
@@ -636,7 +636,7 @@ SELECT * FROM multiout_simple_setof(3);
   </para>
  </sect1>
 
- <sect1 id="plpython-do">
+ <sect1 id="plpython-do" xreflabel="Anonymous Code Blocks">
   <title>Anonymous Code Blocks</title>
 
   <para>
@@ -654,7 +654,7 @@ $$ LANGUAGE plpython3u;
   </para>
  </sect1>
 
- <sect1 id="plpython-trigger">
+ <sect1 id="plpython-trigger" xreflabel="Trigger Functions">
   <title>Trigger Functions</title>
 
   <indexterm zone="plpython-trigger">
@@ -777,7 +777,7 @@ $$ LANGUAGE plpython3u;
   </para>
  </sect1>
 
- <sect1 id="plpython-event-trigger">
+ <sect1 id="plpython-event-trigger" xreflabel="Event Trigger Functions">
   <title>Event Trigger Functions</title>
 
   <indexterm zone="plpython-event-trigger">
@@ -845,7 +845,7 @@ CREATE EVENT TRIGGER pysnitch ON ddl_command_start EXECUTE FUNCTION pysnitch();
   </example>
  </sect1>
 
- <sect1 id="plpython-database">
+ <sect1 id="plpython-database" xreflabel="Database Access">
   <title>Database Access</title>
 
   <para>
@@ -855,7 +855,7 @@ CREATE EVENT TRIGGER pysnitch ON ddl_command_start EXECUTE FUNCTION pysnitch();
    <literal>plpy.<replaceable>foo</replaceable></literal>.
   </para>
 
-  <sect2 id="plpython-database-access-funcs">
+  <sect2 id="plpython-database-access-funcs" xreflabel="Database Access Functions">
     <title>Database Access Functions</title>
 
   <para>
@@ -1115,7 +1115,7 @@ $$ LANGUAGE plpython3u;
 
   </sect2>
 
-  <sect2 id="plpython-trapping">
+  <sect2 id="plpython-trapping" xreflabel="Trapping Errors">
    <title>Trapping Errors</title>
 
    <para>
@@ -1188,7 +1188,7 @@ $$ LANGUAGE plpython3u;
   </sect2>
  </sect1>
 
- <sect1 id="plpython-subtransaction">
+ <sect1 id="plpython-subtransaction" xreflabel="Explicit Subtransactions">
   <title>Explicit Subtransactions</title>
 
   <para>
@@ -1200,7 +1200,7 @@ $$ LANGUAGE plpython3u;
    the form of explicit subtransactions.
   </para>
 
-  <sect2 id="plpython-subtransaction-context-managers">
+  <sect2 id="plpython-subtransaction-context-managers" xreflabel="Subtransaction Context Managers">
    <title>Subtransaction Context Managers</title>
 
    <para>
@@ -1268,7 +1268,7 @@ $$ LANGUAGE plpython3u;
   </sect2>
  </sect1>
 
- <sect1 id="plpython-transactions">
+ <sect1 id="plpython-transactions" xreflabel="Transaction Management">
   <title>Transaction Management</title>
 
   <para>
@@ -1307,7 +1307,7 @@ CALL transaction_test1();
   </para>
  </sect1>
 
- <sect1 id="plpython-util">
+ <sect1 id="plpython-util" xreflabel="Utility Functions">
   <title>Utility Functions</title>
   <para>
    The <literal>plpy</literal> module also provides the functions
@@ -1395,7 +1395,7 @@ plpy.execute("UPDATE tbl SET %s = %s WHERE key = %s" % (
   </para>
  </sect1>
 
- <sect1 id="plpython-python23">
+ <sect1 id="plpython-python23" xreflabel="Python 2 vs. Python 3">
   <title>Python 2 vs. Python 3</title>
 
   <para>
@@ -1406,7 +1406,7 @@ plpy.execute("UPDATE tbl SET %s = %s WHERE key = %s" % (
   </para>
  </sect1>
 
- <sect1 id="plpython-envar">
+ <sect1 id="plpython-envar" xreflabel="Environment Variables">
   <title>Environment Variables</title>
 
   <para>
diff --git a/doc/src/sgml/pltcl.sgml b/doc/src/sgml/pltcl.sgml
index 9fd008a99d7..bcc54f43cb7 100644
--- a/doc/src/sgml/pltcl.sgml
+++ b/doc/src/sgml/pltcl.sgml
@@ -21,7 +21,7 @@
 
   <!-- **** PL/Tcl overview **** -->
 
-  <sect1 id="pltcl-overview">
+  <sect1 id="pltcl-overview" xreflabel="Overview">
    <title>Overview</title>
 
    <para>
@@ -74,7 +74,7 @@
 
   <!-- **** PL/Tcl description **** -->
 
-   <sect1 id="pltcl-functions">
+   <sect1 id="pltcl-functions" xreflabel="PL/Tcl Functions and Arguments">
     <title>PL/Tcl Functions and Arguments</title>
 
     <para>
@@ -240,7 +240,7 @@ $$ LANGUAGE pltcl;
 
    </sect1>
 
-   <sect1 id="pltcl-data">
+   <sect1 id="pltcl-data" xreflabel="Data Values in PL/Tcl">
     <title>Data Values in PL/Tcl</title>
 
     <para>
@@ -254,7 +254,7 @@ $$ LANGUAGE pltcl;
 
    </sect1>
 
-   <sect1 id="pltcl-global">
+   <sect1 id="pltcl-global" xreflabel="Global Data in PL/Tcl">
     <title>Global Data in PL/Tcl</title>
 
     <indexterm zone="pltcl-global">
@@ -316,7 +316,7 @@ $$ LANGUAGE pltcl;
     </para>
    </sect1>
 
-   <sect1 id="pltcl-dbaccess">
+   <sect1 id="pltcl-dbaccess" xreflabel="Database Access from PL/Tcl">
     <title>Database Access from PL/Tcl</title>
 
     <para>
@@ -572,7 +572,7 @@ SELECT 'doesn''t' AS ret
 
    </sect1>
 
-   <sect1 id="pltcl-trigger">
+   <sect1 id="pltcl-trigger" xreflabel="Trigger Functions in PL/Tcl">
     <title>Trigger Functions in PL/Tcl</title>
 
     <indexterm>
@@ -784,7 +784,7 @@ CREATE TRIGGER trig_mytab_modcount BEFORE INSERT OR UPDATE ON mytab
     </para>
    </sect1>
 
-   <sect1 id="pltcl-event-trigger">
+   <sect1 id="pltcl-event-trigger" xreflabel="Event Trigger Functions in PL/Tcl">
     <title>Event Trigger Functions in PL/Tcl</title>
 
     <indexterm>
@@ -843,7 +843,7 @@ CREATE EVENT TRIGGER tcl_a_snitch ON ddl_command_start EXECUTE FUNCTION tclsnitc
     </para>
    </sect1>
 
-   <sect1 id="pltcl-error-handling">
+   <sect1 id="pltcl-error-handling" xreflabel="Error Handling in PL/Tcl">
     <title>Error Handling in PL/Tcl</title>
 
     <indexterm>
@@ -918,7 +918,7 @@ if {[catch { spi_exec $sql_command }]} {
     </para>
    </sect1>
 
-   <sect1 id="pltcl-subtransactions">
+   <sect1 id="pltcl-subtransactions" xreflabel="Explicit Subtransactions in PL/Tcl">
     <title>Explicit Subtransactions in PL/Tcl</title>
 
     <indexterm>
@@ -1000,7 +1000,7 @@ $$ LANGUAGE pltcl;
     </para>
    </sect1>
 
-   <sect1 id="pltcl-transactions">
+   <sect1 id="pltcl-transactions" xreflabel="Transaction Management">
     <title>Transaction Management</title>
 
     <para>
@@ -1041,7 +1041,7 @@ CALL transaction_test1();
     </para>
    </sect1>
 
-   <sect1 id="pltcl-config">
+   <sect1 id="pltcl-config" xreflabel="PL/Tcl Configuration">
     <title>PL/Tcl Configuration</title>
 
     <para>
@@ -1115,7 +1115,7 @@ CALL transaction_test1();
     </variablelist>
    </sect1>
 
-   <sect1 id="pltcl-procnames">
+   <sect1 id="pltcl-procnames" xreflabel="Tcl Procedure Names">
     <title>Tcl Procedure Names</title>
 
     <para>
diff --git a/doc/src/sgml/postgres-fdw.sgml b/doc/src/sgml/postgres-fdw.sgml
index 9b032fbf675..e8e2c97d312 100644
--- a/doc/src/sgml/postgres-fdw.sgml
+++ b/doc/src/sgml/postgres-fdw.sgml
@@ -108,10 +108,10 @@
   of columns to the remote table is by name, not position.
  </para>
 
- <sect2 id="postgres-fdw-options">
+ <sect2 id="postgres-fdw-options" xreflabel="FDW Options of postgres_fdw">
   <title>FDW Options of postgres_fdw</title>
 
-  <sect3 id="postgres-fdw-options-connection">
+  <sect3 id="postgres-fdw-options-connection" xreflabel="Connection Options">
    <title>Connection Options</title>
 
    <para>
@@ -202,7 +202,7 @@ OPTIONS (ADD password_required 'false');
    </para>
   </sect3>
 
-  <sect3 id="postgres-fdw-options-object-name">
+  <sect3 id="postgres-fdw-options-object-name" xreflabel="Object Name Options">
    <title>Object Name Options</title>
 
    <para>
@@ -251,7 +251,7 @@ OPTIONS (ADD password_required 'false');
 
   </sect3>
 
-  <sect3 id="postgres-fdw-options-cost-estimation">
+  <sect3 id="postgres-fdw-options-cost-estimation" xreflabel="Cost Estimation Options">
    <title>Cost Estimation Options</title>
 
    <para>
@@ -368,7 +368,7 @@ OPTIONS (ADD password_required 'false');
 
   </sect3>
 
-  <sect3 id="postgres-fdw-options-remote-execution">
+  <sect3 id="postgres-fdw-options-remote-execution" xreflabel="Remote Execution Options">
    <title>Remote Execution Options</title>
 
    <para>
@@ -453,7 +453,7 @@ OPTIONS (ADD password_required 'false');
 
   </sect3>
 
-  <sect3 id="postgres-fdw-options-asynchronous-execution">
+  <sect3 id="postgres-fdw-options-asynchronous-execution" xreflabel="Asynchronous Execution Options">
    <title>Asynchronous Execution Options</title>
 
    <para>
@@ -504,7 +504,7 @@ OPTIONS (ADD password_required 'false');
    </variablelist>
   </sect3>
 
-  <sect3 id="postgres-fdw-options-transaction-management">
+  <sect3 id="postgres-fdw-options-transaction-management" xreflabel="Transaction Management Options">
    <title>Transaction Management Options</title>
 
    <para>
@@ -569,7 +569,7 @@ OPTIONS (ADD password_required 'false');
 
   </sect3>
 
-  <sect3 id="postgres-fdw-options-updatability">
+  <sect3 id="postgres-fdw-options-updatability" xreflabel="Updatability Options">
    <title>Updatability Options</title>
 
    <para>
@@ -606,7 +606,7 @@ OPTIONS (ADD password_required 'false');
    </variablelist>
   </sect3>
 
-  <sect3 id="postgres-fdw-options-truncatability">
+  <sect3 id="postgres-fdw-options-truncatability" xreflabel="Truncatability Options">
    <title>Truncatability Options</title>
 
    <para>
@@ -637,7 +637,7 @@ OPTIONS (ADD password_required 'false');
    </variablelist>
   </sect3>
 
-  <sect3 id="postgres-fdw-options-importing">
+  <sect3 id="postgres-fdw-options-importing" xreflabel="Importing Options">
    <title>Importing Options</title>
 
    <para>
@@ -745,7 +745,7 @@ OPTIONS (ADD password_required 'false');
 
   </sect3>
 
-  <sect3 id="postgres-fdw-options-connection-management">
+  <sect3 id="postgres-fdw-options-connection-management" xreflabel="Connection Management Options">
     <title>Connection Management Options</title>
 
     <para>
@@ -841,7 +841,7 @@ OPTIONS (ADD password_required 'false');
    </sect3>
  </sect2>
 
-<sect2 id="postgres-fdw-functions">
+<sect2 id="postgres-fdw-functions" xreflabel="Functions">
   <title>Functions</title>
 
   <variablelist>
@@ -1012,7 +1012,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
 
 </sect2>
 
- <sect2 id="postgres-fdw-connection-management">
+ <sect2 id="postgres-fdw-connection-management" xreflabel="Connection Management">
   <title>Connection Management</title>
 
   <para>
@@ -1049,7 +1049,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-transaction-management">
+ <sect2 id="postgres-fdw-transaction-management" xreflabel="Transaction Management">
   <title>Transaction Management</title>
 
   <para>
@@ -1084,7 +1084,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-remote-query-optimization">
+ <sect2 id="postgres-fdw-remote-query-optimization" xreflabel="Remote Query Optimization">
   <title>Remote Query Optimization</title>
 
   <para>
@@ -1127,7 +1127,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-remote-query-execution-environment">
+ <sect2 id="postgres-fdw-remote-query-execution-environment" xreflabel="Remote Query Execution Environment">
   <title>Remote Query Execution Environment</title>
 
   <para>
@@ -1183,7 +1183,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-cross-version-compatibility">
+ <sect2 id="postgres-fdw-cross-version-compatibility" xreflabel="Cross-Version Compatibility">
   <title>Cross-Version Compatibility</title>
 
   <para>
@@ -1213,7 +1213,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-wait-events">
+ <sect2 id="postgres-fdw-wait-events" xreflabel="Wait Events">
   <title>Wait Events</title>
 
   <para>
@@ -1251,7 +1251,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </variablelist>
  </sect2>
 
- <sect2 id="postgres-fdw-configuration-parameters">
+ <sect2 id="postgres-fdw-configuration-parameters" xreflabel="Configuration Parameters">
   <title>Configuration Parameters</title>
 
   <variablelist>
@@ -1351,7 +1351,7 @@ postgres=# SELECT postgres_fdw_disconnect_all();
   </variablelist>
  </sect2>
 
- <sect2 id="postgres-fdw-examples">
+ <sect2 id="postgres-fdw-examples" xreflabel="Examples">
   <title>Examples</title>
 
   <para>
@@ -1415,7 +1415,7 @@ CREATE FOREIGN TABLE foreign_table (
   </para>
  </sect2>
 
- <sect2 id="postgres-fdw-author">
+ <sect2 id="postgres-fdw-author" xreflabel="Author">
   <title>Author</title>
   <para>
    Shigeru Hanada <email>shigeru.hanada@gmail.com</email>
diff --git a/doc/src/sgml/problems.sgml b/doc/src/sgml/problems.sgml
index fc25c715ebb..47ae690f7d0 100644
--- a/doc/src/sgml/problems.sgml
+++ b/doc/src/sgml/problems.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/problems.sgml -->
 
-<sect1 id="bug-reporting">
+<sect1 id="bug-reporting" xreflabel="Bug Reporting Guidelines">
  <title>Bug Reporting Guidelines</title>
 
  <para>
@@ -28,7 +28,7 @@
   If you need help immediately, consider obtaining a commercial support contract.
  </para>
 
- <sect2 id="bug-reporting-identifying-bugs">
+ <sect2 id="bug-reporting-identifying-bugs" xreflabel="Identifying Bugs">
   <title>Identifying Bugs</title>
 
   <para>
@@ -96,7 +96,7 @@
   </para>
  </sect2>
 
- <sect2 id="bug-reporting-what-to-report">
+ <sect2 id="bug-reporting-what-to-report" xreflabel="What to Report">
   <title>What to Report</title>
 
   <para>
@@ -291,7 +291,7 @@
   </para>
  </sect2>
 
- <sect2 id="bug-reporting-where-to-report-bugs">
+ <sect2 id="bug-reporting-where-to-report-bugs" xreflabel="Where to Report Bugs">
   <title>Where to Report Bugs</title>
 
   <para>
diff --git a/doc/src/sgml/protocol.sgml b/doc/src/sgml/protocol.sgml
index 41c5954a424..07611d0064a 100644
--- a/doc/src/sgml/protocol.sgml
+++ b/doc/src/sgml/protocol.sgml
@@ -35,7 +35,7 @@
    are interchangeable.
   </para>
 
- <sect1 id="protocol-overview">
+ <sect1 id="protocol-overview" xreflabel="Overview">
   <title>Overview</title>
 
   <para>
@@ -80,7 +80,7 @@
    such as <command>COPY</command>.
   </para>
 
- <sect2 id="protocol-message-concepts">
+ <sect2 id="protocol-message-concepts" xreflabel="Messaging Overview">
   <title>Messaging Overview</title>
 
   <para>
@@ -113,7 +113,7 @@
   </para>
  </sect2>
 
-  <sect2 id="protocol-query-concepts">
+  <sect2 id="protocol-query-concepts" xreflabel="Extended Query Overview">
    <title>Extended Query Overview</title>
 
    <para>
@@ -155,7 +155,7 @@
    </para>
   </sect2>
 
-  <sect2 id="protocol-format-codes">
+  <sect2 id="protocol-format-codes" xreflabel="Formats and Format Codes">
    <title>Formats and Format Codes</title>
 
    <para>
@@ -188,7 +188,7 @@
    </para>
   </sect2>
 
-  <sect2 id="protocol-versions">
+  <sect2 id="protocol-versions" xreflabel="Protocol Versions">
    <title>Protocol Versions</title>
 
    <para>
@@ -273,7 +273,7 @@
   </sect2>
  </sect1>
 
- <sect1 id="protocol-flow">
+ <sect1 id="protocol-flow" xreflabel="Message Flow">
   <title>Message Flow</title>
 
   <para>
@@ -288,7 +288,7 @@
    after the start-up phase.
   </para>
 
-  <sect2 id="protocol-flow-start-up">
+  <sect2 id="protocol-flow-start-up" xreflabel="Start-up">
    <title>Start-up</title>
 
    <para>
@@ -602,7 +602,7 @@
    </para>
   </sect2>
 
-  <sect2 id="protocol-flow-simple-query">
+  <sect2 id="protocol-flow-simple-query" xreflabel="Simple Query">
    <title>Simple Query</title>
 
    <para>
@@ -774,7 +774,7 @@
     rather than wiring in assumptions about the exact sequence of messages.
    </para>
 
-   <sect3 id="protocol-flow-multi-statement">
+   <sect3 id="protocol-flow-multi-statement" xreflabel="Multiple Statements in a Simple Query">
     <title>Multiple Statements in a Simple Query</title>
 
     <para>
@@ -904,7 +904,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </sect3>
   </sect2>
 
-  <sect2 id="protocol-flow-ext-query">
+  <sect2 id="protocol-flow-ext-query" xreflabel="Extended Query">
    <title>Extended Query</title>
 
    <para>
@@ -1133,7 +1133,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </note>
   </sect2>
 
-  <sect2 id="protocol-flow-pipelining">
+  <sect2 id="protocol-flow-pipelining" xreflabel="Pipelining">
    <title>Pipelining</title>
 
    <indexterm zone="protocol-flow-pipelining">
@@ -1193,7 +1193,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </para>
   </sect2>
 
-  <sect2 id="protocol-flow-function-call">
+  <sect2 id="protocol-flow-function-call" xreflabel="Function Call">
    <title>Function Call</title>
 
    <para>
@@ -1271,7 +1271,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </para>
   </sect2>
 
-  <sect2 id="protocol-copy">
+  <sect2 id="protocol-copy" xreflabel="COPY Operations">
    <title>COPY Operations</title>
 
    <para>
@@ -1379,7 +1379,7 @@ SELCT 1/0;<!-- this typo is intentional -->
 
   </sect2>
 
-  <sect2 id="protocol-async">
+  <sect2 id="protocol-async" xreflabel="Asynchronous Operations">
    <title>Asynchronous Operations</title>
 
    <para>
@@ -1469,7 +1469,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </note>
   </sect2>
 
-  <sect2 id="protocol-flow-canceling-requests">
+  <sect2 id="protocol-flow-canceling-requests" xreflabel="Canceling Requests in Progress">
    <title>Canceling Requests in Progress</title>
 
    <para>
@@ -1533,7 +1533,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </para>
   </sect2>
 
-  <sect2 id="protocol-flow-termination">
+  <sect2 id="protocol-flow-termination" xreflabel="Termination">
    <title>Termination</title>
 
    <para>
@@ -1573,7 +1573,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </para>
   </sect2>
 
-  <sect2 id="protocol-flow-ssl">
+  <sect2 id="protocol-flow-ssl" xreflabel="SSL Session Encryption">
    <title><acronym>SSL</acronym> Session Encryption</title>
 
    <para>
@@ -1682,7 +1682,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </para>
   </sect2>
 
-  <sect2 id="protocol-flow-gssapi">
+  <sect2 id="protocol-flow-gssapi" xreflabel="GSSAPI Session Encryption">
    <title><acronym>GSSAPI</acronym> Session Encryption</title>
 
    <para>
@@ -1776,7 +1776,7 @@ SELCT 1/0;<!-- this typo is intentional -->
   </sect2>
  </sect1>
 
- <sect1 id="sasl-authentication">
+ <sect1 id="sasl-authentication" xreflabel="SASL Authentication">
   <title>SASL Authentication</title>
 
   <para>
@@ -1835,7 +1835,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    ErrorMessage.
   </para>
 
-  <sect2 id="sasl-scram-sha-256">
+  <sect2 id="sasl-scram-sha-256" xreflabel="SCRAM-SHA-256 Authentication">
    <title>SCRAM-SHA-256 Authentication</title>
 
    <para>
@@ -1944,7 +1944,7 @@ SELCT 1/0;<!-- this typo is intentional -->
    </procedure>
   </sect2>
 
-  <sect2 id="sasl-oauthbearer">
+  <sect2 id="sasl-oauthbearer" xreflabel="OAUTHBEARER Authentication">
    <title>OAUTHBEARER Authentication</title>
 
    <para>
@@ -2060,7 +2060,7 @@ SELCT 1/0;<!-- this typo is intentional -->
   </sect2>
  </sect1>
 
- <sect1 id="protocol-replication">
+ <sect1 id="protocol-replication" xreflabel="Streaming Replication Protocol">
   <title>Streaming Replication Protocol</title>
 
   <para>
@@ -3508,7 +3508,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </para>
  </sect1>
 
-<sect1 id="protocol-logical-replication">
+<sect1 id="protocol-logical-replication" xreflabel="Logical Streaming Replication Protocol">
  <title>Logical Streaming Replication Protocol</title>
 
  <para>
@@ -3523,7 +3523,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   the physical streaming replication protocol.
  </para>
 
- <sect2 id="protocol-logical-replication-params">
+ <sect2 id="protocol-logical-replication-params" xreflabel="Logical Streaming Replication Parameters">
   <title>Logical Streaming Replication Parameters</title>
 
   <para>
@@ -3535,7 +3535,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </para>
  </sect2>
 
- <sect2 id="protocol-logical-messages">
+ <sect2 id="protocol-logical-messages" xreflabel="Logical Replication Protocol Messages">
   <title>Logical Replication Protocol Messages</title>
 
   <para>
@@ -3558,7 +3558,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
 
  </sect2>
 
- <sect2 id="protocol-logical-messages-flow">
+ <sect2 id="protocol-logical-messages-flow" xreflabel="Logical Replication Protocol Message Flow">
   <title>Logical Replication Protocol Message Flow</title>
 
   <para>
@@ -3612,7 +3612,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
  </sect2>
 </sect1>
 
- <sect1 id="protocol-message-types">
+ <sect1 id="protocol-message-types" xreflabel="Message Data Types">
   <title>Message Data Types</title>
 
   <para>
@@ -3684,7 +3684,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </variablelist>
  </sect1>
 
- <sect1 id="protocol-message-formats">
+ <sect1 id="protocol-message-formats" xreflabel="Message Formats">
   <title>Message Formats</title>
 
   <para>
@@ -6225,7 +6225,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </variablelist>
  </sect1>
 
- <sect1 id="protocol-error-fields">
+ <sect1 id="protocol-error-fields" xreflabel="Error and Notice Message Fields">
   <title>Error and Notice Message Fields</title>
 
   <para>
@@ -6463,7 +6463,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </para>
  </sect1>
 
- <sect1 id="protocol-logicalrep-message-formats">
+ <sect1 id="protocol-logicalrep-message-formats" xreflabel="Logical Replication Message Formats">
   <title>Logical Replication Message Formats</title>
 
   <para>
@@ -7760,7 +7760,7 @@ psql "dbname=postgres replication=database" -c "IDENTIFY_SYSTEM;"
   </variablelist>
  </sect1>
 
- <sect1 id="protocol-changes">
+ <sect1 id="protocol-changes" xreflabel="Summary of Changes since Protocol 2.0">
   <title>Summary of Changes since Protocol 2.0</title>
 
   <para>
diff --git a/doc/src/sgml/queries.sgml b/doc/src/sgml/queries.sgml
index 4b522213171..0abeecb159b 100644
--- a/doc/src/sgml/queries.sgml
+++ b/doc/src/sgml/queries.sgml
@@ -18,7 +18,7 @@
  </para>
 
 
- <sect1 id="queries-overview">
+ <sect1 id="queries-overview" xreflabel="Overview">
   <title>Overview</title>
 
   <para>
@@ -80,7 +80,7 @@ SELECT random();
  </sect1>
 
 
- <sect1 id="queries-table-expressions">
+ <sect1 id="queries-table-expressions" xreflabel="Table Expressions">
   <title>Table Expressions</title>
 
   <indexterm zone="queries-table-expressions">
@@ -106,7 +106,7 @@ SELECT random();
    the select list to compute the output rows of the query.
   </para>
 
-  <sect2 id="queries-from">
+  <sect2 id="queries-from" xreflabel="The FROM Clause">
    <title>The <literal>FROM</literal> Clause</title>
 
    <para>
@@ -150,7 +150,7 @@ FROM <replaceable>table_reference</replaceable> <optional>, <replaceable>table_r
     However, it is supported for compatibility with older releases.
    </para>
 
-   <sect3 id="queries-join">
+   <sect3 id="queries-join" xreflabel="Joined Tables">
     <title>Joined Tables</title>
 
     <indexterm zone="queries-join">
@@ -530,7 +530,7 @@ FROM <replaceable>table_reference</replaceable> <optional>, <replaceable>table_r
     </para>
    </sect3>
 
-   <sect3 id="queries-table-aliases">
+   <sect3 id="queries-table-aliases" xreflabel="Table and Column Aliases">
     <title>Table and Column Aliases</title>
 
     <indexterm zone="queries-table-aliases">
@@ -628,7 +628,7 @@ SELECT a.* FROM (my_table AS a JOIN your_table AS b ON ...) AS c
     </para>
    </sect3>
 
-   <sect3 id="queries-subqueries">
+   <sect3 id="queries-subqueries" xreflabel="Subqueries">
     <title>Subqueries</title>
 
     <indexterm zone="queries-subqueries">
@@ -672,7 +672,7 @@ FROM (VALUES ('anne', 'smith'), ('bob', 'jones'), ('joe', 'blow'))
     </para>
    </sect3>
 
-   <sect3 id="queries-tablefunctions">
+   <sect3 id="queries-tablefunctions" xreflabel="Table Functions">
     <title>Table Functions</title>
 
     <indexterm zone="queries-tablefunctions"><primary>table function</primary></indexterm>
@@ -839,7 +839,7 @@ ORDER BY p;
     </para>
    </sect3>
 
-   <sect3 id="queries-lateral">
+   <sect3 id="queries-lateral" xreflabel="LATERAL Subqueries">
     <title><literal>LATERAL</literal> Subqueries</title>
 
     <indexterm zone="queries-lateral">
@@ -933,7 +933,7 @@ WHERE pname IS NULL;
    </sect3>
   </sect2>
 
-  <sect2 id="queries-where">
+  <sect2 id="queries-where" xreflabel="The WHERE Clause">
    <title>The <literal>WHERE</literal> Clause</title>
 
    <indexterm zone="queries-where">
@@ -1022,7 +1022,7 @@ SELECT ... FROM fdt WHERE EXISTS (SELECT c1 FROM t2 WHERE c2 &gt; fdt.c1)
   </sect2>
 
 
-  <sect2 id="queries-group">
+  <sect2 id="queries-group" xreflabel="The GROUP BY and HAVING Clauses">
    <title>The <literal>GROUP BY</literal> and <literal>HAVING</literal> Clauses</title>
 
    <indexterm zone="queries-group">
@@ -1241,7 +1241,7 @@ SELECT product_id, p.name, (sum(s.units) * (p.price - p.cost)) AS profit
    </para>
   </sect2>
 
-  <sect2 id="queries-grouping-sets">
+  <sect2 id="queries-grouping-sets" xreflabel="GROUPING SETS, CUBE, and ROLLUP">
    <title><literal>GROUPING SETS</literal>, <literal>CUBE</literal>, and <literal>ROLLUP</literal></title>
 
    <indexterm zone="queries-grouping-sets">
@@ -1465,7 +1465,7 @@ GROUP BY GROUPING SETS (
   </note>
   </sect2>
 
-  <sect2 id="queries-window">
+  <sect2 id="queries-window" xreflabel="Window Function Processing">
    <title>Window Function Processing</title>
 
    <indexterm zone="queries-window">
@@ -1510,7 +1510,7 @@ GROUP BY GROUPING SETS (
  </sect1>
 
 
- <sect1 id="queries-select-lists">
+ <sect1 id="queries-select-lists" xreflabel="Select Lists">
   <title>Select Lists</title>
 
   <indexterm>
@@ -1528,7 +1528,7 @@ GROUP BY GROUPING SETS (
    intermediate table are actually output.
   </para>
 
-  <sect2 id="queries-select-list-items">
+  <sect2 id="queries-select-list-items" xreflabel="Select-List Items">
    <title>Select-List Items</title>
 
    <indexterm>
@@ -1579,7 +1579,7 @@ SELECT tbl1.*, tbl2.a FROM ...
    </para>
   </sect2>
 
-  <sect2 id="queries-column-labels">
+  <sect2 id="queries-column-labels" xreflabel="Column Labels">
    <title>Column Labels</title>
 
    <indexterm zone="queries-column-labels">
@@ -1638,7 +1638,7 @@ SELECT a "from", b + c AS sum FROM ...
    </note>
   </sect2>
 
-  <sect2 id="queries-distinct">
+  <sect2 id="queries-distinct" xreflabel="DISTINCT">
    <title><literal>DISTINCT</literal></title>
 
    <indexterm zone="queries-distinct">
@@ -1706,7 +1706,7 @@ SELECT DISTINCT ON (<replaceable>expression</replaceable> <optional>, <replaceab
  </sect1>
 
 
- <sect1 id="queries-union">
+ <sect1 id="queries-union" xreflabel="Combining Queries (UNION, INTERSECT, EXCEPT)">
   <title>Combining Queries (<literal>UNION</literal>, <literal>INTERSECT</literal>, <literal>EXCEPT</literal>)</title>
 
   <indexterm zone="queries-union">
@@ -1819,7 +1819,7 @@ SELECT a FROM b UNION (SELECT x FROM y LIMIT 10)
  </sect1>
 
 
- <sect1 id="queries-order">
+ <sect1 id="queries-order" xreflabel="Sorting Rows (ORDER BY)">
   <title>Sorting Rows (<literal>ORDER BY</literal>)</title>
 
   <indexterm zone="queries-order">
@@ -1920,7 +1920,7 @@ SELECT a + b AS sum, c FROM table1 ORDER BY sum + c;          -- wrong
  </sect1>
 
 
- <sect1 id="queries-limit">
+ <sect1 id="queries-limit" xreflabel="LIMIT and OFFSET">
   <title><literal>LIMIT</literal> and <literal>OFFSET</literal></title>
 
   <indexterm zone="queries-limit">
@@ -1994,7 +1994,7 @@ SELECT <replaceable>select_list</replaceable>
  </sect1>
 
 
- <sect1 id="queries-values">
+ <sect1 id="queries-values" xreflabel="VALUES Lists">
   <title><literal>VALUES</literal> Lists</title>
 
   <indexterm zone="queries-values">
@@ -2070,7 +2070,7 @@ SELECT <replaceable>select_list</replaceable> FROM <replaceable>table_expression
  </sect1>
 
 
- <sect1 id="queries-with">
+ <sect1 id="queries-with" xreflabel="WITH Queries (Common Table Expressions)">
   <title><literal>WITH</literal> Queries (Common Table Expressions)</title>
 
   <indexterm zone="queries-with">
@@ -2096,7 +2096,7 @@ SELECT <replaceable>select_list</replaceable> FROM <replaceable>table_expression
    <command>DELETE</command>, or <command>MERGE</command>.
   </para>
 
- <sect2 id="queries-with-select">
+ <sect2 id="queries-with-select" xreflabel="SELECT in WITH">
    <title><command>SELECT</command> in <literal>WITH</literal></title>
 
   <para>
@@ -2134,7 +2134,7 @@ GROUP BY region, product;
   </para>
  </sect2>
 
- <sect2 id="queries-with-recursive">
+ <sect2 id="queries-with-recursive" xreflabel="Recursive Queries">
   <title>Recursive Queries</title>
 
   <para>
@@ -2238,7 +2238,7 @@ GROUP BY sub_part
 </programlisting>
   </para>
 
-  <sect3 id="queries-with-search">
+  <sect3 id="queries-with-search" xreflabel="Search Order">
    <title>Search Order</title>
 
    <para>
@@ -2373,7 +2373,7 @@ SELECT * FROM search_tree ORDER BY ordercol;
    </para>
   </sect3>
 
-  <sect3 id="queries-with-cycle">
+  <sect3 id="queries-with-cycle" xreflabel="Cycle Detection">
    <title>Cycle Detection</title>
 
   <para>
@@ -2520,7 +2520,7 @@ SELECT n FROM t <emphasis>LIMIT 100</emphasis>;
   </sect3>
  </sect2>
 
- <sect2 id="queries-with-cte-materialization">
+ <sect2 id="queries-with-cte-materialization" xreflabel="Common Table Expression Materialization">
   <title>Common Table Expression Materialization</title>
 
   <para>
@@ -2622,7 +2622,7 @@ SELECT * FROM w AS w1 JOIN w AS w2 ON w1.f = w2.f;
   </para>
  </sect2>
 
- <sect2 id="queries-with-modifying">
+ <sect2 id="queries-with-modifying" xreflabel="Data-Modifying Statements in WITH">
    <title>Data-Modifying Statements in <literal>WITH</literal></title>
 
    <para>
